import requests

from .instance import Instance


class Proposal:

    def __init__(self, proposal_id: int):
        self._proposal_id = proposal_id
        self._instance = Instance()
        self._username = 'proposalIngestor'
        self._pw = '#V7na'

    @property
    def proposal_id(self) -> int:
        return self._proposal_id

    @property
    def proposal(self) -> dict:
        return self._get_proposal()

    def _get_proposal(self):
        token = self._get_token()
        self._instance.headers["Authorization"] = "Bearer {}".format(token)
        url = f"{self._instance.scicat_url}/Proposals/{self._proposal_id}?access_token=Bearer%20{token}"
        response = requests.get(url, headers=self._instance.headers)
        if response.ok:
            return response.json()
        else:
            raise Exception(f"{response.text}")

    def _get_token(self) -> str:
        url = f"{self._instance.scicat_url}/users/login"
        response = requests.post(url, headers=self._instance.headers,
                                 json={"username": self._username,
                                       "password": self._pw})
        if response.ok:
            return response.json()["id"]
        else:
            raise Exception(f"{response.text}")
